unit Main;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Buttons, Messages, ComCtrls, EMSQDWindow, db, DBTables,
  ExtCtrls, EMSQDFloatTable, EMSQDFloatPanel;

type
  TMainForm = class(TForm)
    StatusBar: TStatusBar;
    Table1: TTable;
    Panel1: TPanel;
    Tables: TComboBox;
    Label1: TLabel;
    Button2: TButton;
    Label2: TLabel;
    Databases: TComboBox;
    emsQueryBuilder1: TemsQueryBuilder;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button2Click(Sender: TObject);
    procedure TablesChange(Sender: TObject);
    procedure _GetFields(NameOfTable: String; var ADataSet: TDataSet);
    procedure DatabasesChange(Sender: TObject);
    procedure emsQueryBuilder1GetTableFields(NameOfTable: String;
      var ADataSet: TDataSet; var AParams: TParams);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

uses Memo;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Databases.Clear;
  Session.GetDatabaseNames(Databases.Items);

  Tables.Clear;
  Tables.Enabled:=false;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Table1.Active:=false;
  Action := caFree;
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  MemoSQL.Query1.Close;
  MemoSQL.Query1.DatabaseName:=Databases.Text;
  MemoSQL.Memo1.Text:=emsQueryBuilder1.SQL;
  if (MemoSQL.ShowModal=mrOK) and (MemoSQL.Memo1.Text<> '') then
    emsQueryBuilder1.SQL:=MemoSQL.Memo1.Text;
end;

procedure TMainForm._GetFields(NameOfTable: String; var ADataSet: TDataSet);
var
  Tbl: TTable;
begin
  Tbl:=TTable.Create(Self);
  Tbl.DatabaseName:=Table1.DatabaseName;
  Tbl.TableName:=NameOfTable;
  Tbl.Active:=true;
  ADataSet:=Tbl;
end;

procedure TMainForm.TablesChange(Sender: TObject);
begin
  Table1.Active:=false;
  Table1.DatabaseName:=Databases.Text;
  Table1.TableName:=Tables.Text;
  Table1.Active:=true;
  emsQueryBuilder1.Tables.AddTable(Tables.Text, Table1);
end;

procedure TMainForm.DatabasesChange(Sender: TObject);
begin
  Table1.Active:=false;
  Tables.Clear;
  Session.GetTableNames(Databases.Text,'', true, false, Tables.Items);
  Tables.ItemIndex:=0;
  Tables.Enabled:=true;
end;

procedure TMainForm.emsQueryBuilder1GetTableFields(NameOfTable: String;
  var ADataSet: TDataSet; var AParams: TParams);
var
  Tbl: TTable;
begin
  Tbl:=TTable.Create(Self);
  Tbl.DatabaseName:=Table1.DatabaseName;
  Tbl.TableName:=NameOfTable;
  Tbl.Active:=true;
  ADataSet:=Tbl;
end;

end.
