unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, EMSQDWindow, IBDatabase, Db, IBTable,
  DBCtrls, Grids, DBGrids, IBCustomDataSet, IBQuery, EMSQDFloatPanel,
  EMSQDFloatTable;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    cbTables: TComboBox;
    edDataBase: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Button1: TButton;
    dlgDatabase: TOpenDialog;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    Button2: TButton;
    Button3: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    IBQuery1: TIBQuery;
    DBGrid1: TDBGrid;
    Memo1: TMemo;
    DataSource1: TDataSource;
    btnOpers: TButton;
    Splitter1: TSplitter;
    emsQueryBuilder1: TemsQueryBuilder;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure cbTablesChange(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure btnOpersClick(Sender: TObject);
    procedure emsQueryBuilder1GetTableFields(NameOfTable: String;
      var ADataSet: TDataSet; var AParams: TParams);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SQLForm;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if dlgDatabase.Execute then
    edDatabase.Text:=dlgDatabase.FileName;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  IBQuery1.Active:=false;
  cbTables.Enabled:=false;
  IBDatabase1.Connected:=false;
  IBDatabase1.DatabaseName:=edDataBase.Text;
  IBDatabase1.Params.Clear;
  IBDatabase1.Params.Add('USER_NAME=SYSDBA');
  IBDatabase1.Params.Add('PASSWORD=masterkey');
  IBDatabase1.LoginPrompt:=false;
  try IBDatabase1.Connected:=true;
  except
    IBDatabase1.Params.Clear;
    IBDatabase1.LoginPrompt:=true;
    IBDatabase1.Connected:=true;
  end;
  cbTables.Enabled:=true;
  cbTables.Clear;
  IBDatabase1.GetTableNames(cbTables.Items,false);
  cbTables.ItemIndex:=0;
end;

procedure TForm1.cbTablesChange(Sender: TObject);
var
  FIBTable: TIBTable;
begin
  FIBTable:=TIBTable.Create(Self);
  if IBDatabase1=nil then raise Exception.Create('Database not assigned');
  FIBTable.Database:=IBDatabase1;
  FIBTable.TableName:=cbTables.Text;
  FIBTable.Active:=true;
  emsQueryBuilder1.Tables.AddTable(cbTables.Text, FIBTable);
  FIBTable.Free;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  SQLText.Memo1.Text:=emsQueryBuilder1.SQL;
  if SQLText.ShowModal=mrOK then
    emsQueryBuilder1.SQL:=SQLText.Memo1.Text;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePageIndex=0 then begin //Load SQL
    IBQuery1.Active:=false;
    emsQueryBuilder1.SQL:=Memo1.Text;
  end else begin//Exec SQL
    IBQuery1.SQL.Clear;
    Memo1.Text:=emsQueryBuilder1.SQL;
    IBQuery1.Active:=false;
    IBQuery1.SQL.Add(emsQueryBuilder1.SQL);
    IBQuery1.Open;
  end;
end;

procedure TForm1.btnOpersClick(Sender: TObject);
begin
  emsQueryBuilder1.ModifyOperators([erAdd, erName, erDelete, erArgument]);
end;

procedure TForm1.emsQueryBuilder1GetTableFields(NameOfTable: String;
  var ADataSet: TDataSet; var AParams: TParams);
var
  IBTbl: TIBTable;
begin
  IBTbl:=TIBTable.Create(Self);
  if IBDatabase1=nil then raise Exception.Create('Database not assigned');
  IBTbl.Database:=IBDatabase1;
  IBTbl.TableName:=NameOfTable;
  IBTbl.Active:=true;
  ADataSet:=IBTbl;
end;

end.
